' $Header: /a/newcmds/kill/RCS/kill.man,v 1.2 88/12/30 09:33:58 ouster Exp $ SPRITE (Berkeley)
.so \*(]ltmac.sprite
.HS KILL cmds
.BS
.SH NAME
kill \- Send a signal to a process or group
.SH SYNOPSIS
\fBkill\fR [\fIoptions\fR] \fIpid pid ...\fR
.SH OPTIONS
.IP "\fB\-g\fR" 15
Treat each \fIpid\fR as the name of a process group rather than a process,
and send the given signal to the entire group.
.IP "\fB\-help\fR" 15
Print a summary of the command-line options and exit without sending
any signals.
.IP "\fB\-l\fR" 15
Print out a list of valid signal names and
exit without sending any signals.
.IP "\fB\-\fIsignal\fR" 15
Send \fIsignal\fR to the given processes.  \fISignal\fR may be either
a number or a symbolic name.  The legal names are the same as the
names from the <signal.h> include file, except without the ``SIG''
prefix.  \fISignal\fR defaults to \fBTERM\fR.
.BE

.SH DESCRIPTION
.LP
This command sends a signal (usually a SIGTERM kill signal) to
one or more processes.  Depending on how the processes have
arranged for the signal to be handled, the processes may exit,
enter the debugger, ignore the signal altogether, or execute a
handler procedure within the process.  In the default case where
the SIGTERM signal is used, the normal result is for the process
to exit.
See the \fBsigvec\fR manual page for more details on signal handling.
.LP
Note:  The C-shell (csh) contains a built-in command \fBkill\fR that
behaves almost identically to this command (it doesn't support the
\fB\-g\fR or \fB\-help\fR options, but is otherwise the same).  If you
are running the C-shell and type \fBkill\fR, you will get the built-in
command:  to get the program version, invoke \fBkill\fR by typing its
absolute path name.

.SH "SEE ALSO"
sigvec

.SH KEYWORDS
group, kill, process, signal
