.\" Copyright (c) 1983 Regents of the University of California.
.\" All rights reserved.  The Berkeley software License Agreement
.\" specifies the terms and conditions for redistribution.
.\"
.\"	@(#)lpc.8	6.1 (Berkeley) 4/27/85
.\"
.TH LPC 8 "April 27, 1985"
.UC 5
.ad
.SH NAME
lpc \- line printer control program
.SH SYNOPSIS
.B lpc
[ command [ argument ... ] ]
.SH DESCRIPTION
.I Lpc
is used by the system administrator to control the
operation of the line printer system.  
For each line printer configured in /etc/printcap,
.I lpc
may be used to:
.IP \(bu
disable or enable a printer,
.IP \(bu
disable or enable a printer's spooling queue,
.IP \(bu
rearrange the order of jobs in a spooling queue,
.IP \(bu
find the status of printers, and their associated
spooling queues and printer dameons.
.PP
Without any arguments,
.I lpc
will prompt for commands from the standard input.
If arguments are supplied,
.IR lpc
interprets the first argument as a command and the remaining
arguments as parameters to the command.  The standard input
may be redirected causing
.I lpc
to read commands from file.
Commands may be abreviated;
the following is the list of recognized commands.
.TP
? [ command ... ]
.TP
help [ command ... ]
.br
Print a short description of each command specified in the argument list,
or, if no arguments are given, a list of the recognized commands.
.TP
abort { all | printer ... }
.br
Terminate an active spooling daemon on the local host immediately and
then disable printing (preventing new daemons from being started by
.IR lpr )
for the specified printers.
.TP
clean { all | printer ... }
.br
Remove any temporary files, data files, and control files that cannot
be printed (i.e., do not form a complete printer job)
from the specified printer queue(s) on the local machine.
.TP
disable { all | printer ... }
.br
Turn the specified printer queues off.  This prevents new
printer jobs from being entered into the queue by
.IR lpr .
.TP
down { all | printer } message ...
.br
Turn the specified printer queue off, disable printing and put
.I message
in the printer status file. The message doesn't need to be quoted, the
remaining arguments are treated like
.IR echo (1).
This is normally used to take a printer down and let others know why
(lpq will indicate the printer is down and print the status message).
.TP
enable { all | printer ... }
.br
Enable spooling on the local queue for the listed printers. 
This will allow
.I lpr
to put new jobs in the spool queue.
.TP
exit
.TP
quit
.br
Exit from lpc.
.TP
restart { all | printer ... }
.br
Attempt to start a new printer daemon. 
This is useful when some abnormal condition causes the daemon to
die unexpectedly leaving jobs in the queue.
.I Lpq
will report that there is no daemon present when this condition occurs. 
If the user is the super-user,
try to abort the current daemon first (i.e., kill and restart a stuck daemon).
.TP
start { all | printer ... }
.br
Enable printing and start a spooling daemon for the listed printers.
.TP
status { all | printer ... }
Display the status of daemons and queues on the local machine.
.TP
stop { all | printer ... }
.br
Stop a spooling daemon after the current job completes and disable
printing.
.TP
topq printer [ jobnum ... ] [ user ... ]
.br
Place the jobs in the order listed at the top of the printer queue.
.TP
up { all | printer ... }
.br
Enable everything and start a new printer daemon. Undoes the effects of
.IR down .
.SH FILES
.nf
.ta \w'/etc/printcap           'u
/etc/printcap	printer description file
/usr/spool/*	spool directories
/usr/spool/*/lock	lock file for queue control
.fi
.SH "SEE ALSO"
lpd(8),
lpr(1),
lpq(1),
lprm(1),
printcap(5)
.SH DIAGNOSTICS
.nf
.ta \w'?Ambiguous command      'u
?Ambiguous command	abreviation matches more than one command
?Invalid command	no match was found
?Privileged command	command can be executed by root only
.fi
