' $Header: /sprite/src/cmds/man/RCS/man.man,v 1.6 91/01/08 21:48:08 tve Exp $ SPRITE (Berkeley)
.so \*(]ltmac.sprite
.HS MAN cmds
.BS
.SH NAME
man \- Print entries in the user reference manual
.SH SYNOPSIS
\fBman\fR [\fIoptions\fR] [\fIsectionNumber\fR] \fIentryName entryName ...\fR
.SH OPTIONS
.IP "\fB\-a\fR" 15
Search all man directories.  By default, directories marked "ALL" in the
configure file will be skipped.  In Sprite, the \fB\-a\fR flag will cause
Software Warehouse directories to be searched.
.IP "\fB\-c \fIconfigFile\fR" 15
\fBMan\fR normally looks in the file \fB/sprite/lib/man/config\fR for
information about where the man pages are.  If the \fB\-c\fR switch is given,
then \fBman\fR uses \fIconfigFile\fR instead.
.IP "\fB\-i\fR" 15
Generate index.  Instead of printing manual entries, treat each
\fIentryName\fR as a file name.  Read all the files, and output index
information on standard output.
.IP "\fB\-help\fR" 15
Print a summary of the command-line options and exit without printing
any manual pages.
.IP "\fB\-k\fR" 15
Keyword search.  Instead of printing manual entries, treat each \fIentryName\fR
argument as a keyword, search the manual indexes for information about
the keywords, and print all the matching index entries.
.IP "\fB\-r\fR" 15
Normally, \fBman\fR retains formatted versions of man pages for faster printing.
It only reformats a man page if there is no formatted version or if the
source is newer than the formatted version.  This switch causes \fBman\fR to
reformat the man page even if the formatted copy appears to be up-to-date.
.IP "\fB\-s \fIsectionName\fR" 15
Check only in section \fIsectionName\fR of the manual for the desired
entries.
.IP "\fB\-t\fR" 15
Print the manual entries on the printer instead of on
standard output.
.IP "\fB\-\fR" 15
\fBMan\fR normally filters the man pages through \fBmore -s\fR to break up
the output and process underline and boldface requests.  If the \fB\-\fR
switch is given, then the \fBmore\fR filter is omitted, and the \fBnroff\fR
output is passed directly to standard output. The \fBPAGER\fP environment
variable can be set to the name of a program to use instead of \fBmore\fP.
.BE

.SH DESCRIPTION
.PP
The \fBman\fR program locates and prints one or more entries of the
Sprite reference manual.  The entries are given by the \fIentryName\fR
arguments;  these are usually the names of programs or library
procedures.  Normally, \fBman\fR searches the entire manual and invokes
\fBmore\fR to print the
first entry that matches each \fIentryName\fR.  The manual is divided
into sections, and it is possible for the same name to be used for
entries in different sections.  You may use the
\fB\-s\fR switch to specify a particular section;  in this case, \fBman\fR
will look only in the named section.  Section names include both the
traditional UNIX names (\fB1\fR, \fB2\fR, etc.) and the Sprite names
(\fBcmds\fR, \fBlib\fR, \fBlib/c\fR, \fBdev\fR, etc.).
You may specify a section name without the \fB\-s\fR switch
if the section name starts with a number and is entered as the first
\fIentryName\fR.
.PP
The default configuration file causes the current directory to be
searched for the desired manual entry before the system directories.
If there is a file \fIentryName\fB.man\fR in the current directory,
then it will be printed in preference to any entries in the system
area.
.PP
The \fB\-i\fR switch causes \fBman\fR to generate an index
instead of printing a manual page.  Each \fIentryName\fR argument
is taken to be a file name.  \fBMan\fR will read all the files and
output index information for them on standard output.  Normally, each
directory containing installed unformatted manual entries also has
a file named \fBindex\fR containing index information for all the files
in the directory.  When printing manual entries, if \fBman\fR cannot
locate a file for a given \fIentryName\fR, then it reads the \fBindex\fR
files to see if \fIentryName\fR is an alternate name for some other
manual entry (an alternate name is any name listed in the \fBNAME\fR
section of the entry).
.PP
The \fB\-k\fR switch causes \fBman\fR to perform a keyword search instead
of printing a manual page.  Each \fIentryName\fR argument is taken to
be a keyword, and \fBman\fR searches all the \fBindex\fR files for
entries that match the keywords.
Each matching entry is printed on standard output in a human-readable form.
A keyword matches an index entry if
it is a substring of any of the entry's name, synopsis, or keyword fields.

.SH FILES
/sprite/lib/man/config \- default configuration file

.SH KEYWORDS
help, index, keyword, manual, reference, section
