.\" @(#)rpcinfo.8c	1.1 87/11/04 3.9 RPCSRC
.TH RPCINFO 8C "3 November 1987"
.SH NAME
rpcinfo \- report RPC information
.SH SYNOPSIS
.B "rpcinfo \-p"
[
.I host
]
.LP
.B "rpcinfo \-u"
.I host
.I program
[
.I version
]
.LP
.B "rpcinfo \-t"
.I host
.I program
[
.I version
]
.LP
.B "rpcinfo \-b"
.I program
.I version
.SH DESCRIPTION
.IX  "rpcinfo command"  ""  "\fLrpcinfo\fP \(em report RPC information"
.IX RPC "report RPC information \(em \fLrpcinfo\fR"
.B rpcinfo
makes an
.SM RPC
call to an
.SM RPC
server and reports what it finds.
.SH OPTIONS
.TP
.B \-p
Probe the portmapper on
.IR host ,
and print a list of all registered
.SM RPC
programs.  If
.I host
is not specified, it defaults to the value returned by
.BR hostname (1).
.TP
.B \-u
Make an
.SM RPC
call to procedure 0 of
.I program
on the specified
.I host
using
.SM UDP\s0,
and report whether a response was received.
.TP
.B \-t
Make an
.SM RPC
call to procedure 0 of
.I program
on the specified
.I host
using
.SM TCP\s0,
and report whether a response was received.
.TP
.B \-b
Make an
.SM RPC
broadcast to procedure 0 of the specified
.I program
and
.I version
using
.SM UDP
and report all hosts that respond.
.LP
The
.I program
argument can be either a name or a number.
.LP
If a
.I version
is specified,
.B rpcinfo
attempts to call that version of the specified
.IR program .
Otherwise,
.B rpcinfo
attempts to find all the registered version
numbers for the specified
.I program
by calling version 0 (which is presumed not
to exist; if it does exist,
.B rpcinfo
attempts to obtain this information by calling
an extremely high version
number instead) and attempts to call each registered version.
Note: the version number is required for the
.B \-b
option.
.SH EXAMPLES
To show all of the
.SM RPC
services registered on the local machine use:
.IP
.B example% rpcinfo -p
.LP
To show all of the
.SM RPC
services registered on the machine named
.B klaxon
use:
.IP
.B example% rpcinfo -p klaxon
.LP
To show all machines on the local net that are running the Yellow Pages
service use:
.IP
.B "example% rpcinfo -b ypserv 'version' | uniq"
.LP
where 'version' is the current Yellow Pages version obtained from the
results of the
.B \-p
switch above.
.SH "SEE ALSO"
.BR rpc (5),
.BR portmap (8C)
.LP
.I "\s-1RPC\s0 Programming Guide"
in
.TX NETP
.SH BUGS
In releases prior to Sun\s-1OS\s0
3.0, the Network File System (\s-1NFS\s0) did not
register itself with the
portmapper;
.B rpcinfo
cannot be used to make
.SM RPC
calls to the
.SM NFS
server on hosts running such releases.
