'\" Copyright 1989 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /sprite/src/cmds/shutdown/RCS/shutdown.man,v 1.5 89/11/28 15:50:14 douglis Exp $ SPRITE (Berkeley)
'/" 
.so \*(]ltmac.sprite
.HS SHUTDOWN cmds
.BS
.SH NAME
shutdown \- shutdown and possibly reboot the system
.SH SYNOPSIS
\fBshutdown \fR[\fB\-hSrdfq\fR] [\fB\-R \fIrebootStr\fR] [\fB\-S \fIsleepTime\fR]
.SH OPTIONS
.IP "\fB\-d\fR" 18
Enter the debugger after shutting the system down.
.IP "\fB\-f\fR" 18
Don't check the disks when rebooting.  Unless the \fB\-d\fR or \fB\-h\fR
options are specified then \fB\-f\fR implies \fB\-r\fR.
.IP "\fB\-h\fR" 18
Force the system to halt.  This is the default unless the \fB\-f\fR or
\fB\-s\fR options are
used.
.IP "\fB\-r\fR" 18
Reboot instead of halt.  This will use whatever is the default reboot string
of the hardware.
.IP "\fB\-R \fIrebootStr\fR" 18
Reboot the system with \fIrebootStr\fR as the string to reboot with.
.IP "\fB\-w\fR" 18
Don't write the file system cache back to disk or to the server.
The default is to write it back.
.IP "\fB\-s\fR" 18
Reboot single user mode. Unless the \fB\-d\fR or \fB\-h\fR
options are specified then \fB\-s\fR implies \fB\-r\fR.
.IP "\fB\-c\fR" 18
Reboot a fileserver as a client.  This causes a fileserver to ignore the
/boot directory on its local root partition. See the \fBboot\fR man
page for more details.
.IP "\fB\-x\fR" 18
Causes a fileserver to run \fBrootcmds\fR before \fBdiskcmds\fR on reboot.
.IP "\fB\-q\fR" 18
Do not use \fIwall\fR to announce the shutdown and do not pause before
shutting down. 
.IP "\fB\-S \fIsleepTime\fR" 18
Sleep \fIsleepTime\fR seconds after running \fIwall\fR.
.BE

.SH INTRODUCTION
.LP
This command shuts down the operating system.  By default the system
is halted. However the system can be made to reboot or enter the debugger
by specifying the correct options.  By default, the shutdown is
announced (on the local host only) using \fIwall\fR and the shutdown
is delayed by several 
seconds to give people a chance to complain.  
.SH KEYWORDS
halt, reboot, shutdown, fastboot, boot
